////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where template files can be found.
path "C:\\Program Files\\GStudio6\\template_6";	// Path to A6 templates directory
path "C:\\Program Files\\GStudio6\\template_6\\code";	// Path to A6 template code subdirectory
path "C:\\Program Files\\GStudio6\\template_6\\images";	// Path to A6 template image subdirectory
path "C:\\Program Files\\GStudio6\\template_6\\models";

/////////////////////////////////////////////////////////////////
// Filename of the starting level.
string level_str = <froggyboxing.wmb>; // give file names in angular brackets

////////////////////////////////////////////////////////////////////////////
// Included files
//include <gid01.wdl>;	// global ids
//include <display00.wdl>;  // basic display settings
include <defines.wdl>;
include <frog1_action.wdl>;
include <frog2_action.wdl>;
/////////////////////////////////////////////////////////////////

// Starting engine values
ifdef lores;
var video_mode = 4; // 320x240
ifelse;
var video_mode = 6; // 640x480
endif;
var video_depth = 16; // D3D, 16 bit resolution
var fps_max = 50; // 50 fps max

/////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////

// define a splash screen with the required A6 logo
bmap splashmap = <logodark.pcx>; // the default A6 logo in templates
panel splashscreen { bmap = splashmap; flags = refresh,d3d; }

//Globals
var anim;
var irrit_f1=0;
var moveme[3];
var campoint[3];
var f1[3]; 
var f2[3];

var right_health = 100;
var left_health = 100;

var prudent = 1;
var defensive = 2;
var offensive = 3;
var otto_state_of_mind;

var waiting = 1;
var dodging = 2;
var punching = 3;
var pain = 4;
var dead = 5;
var win = 6;

var otto_action_state;
var herbie_action_state;

var start_block = 0;
var end_block = 2;
var start_fall = 3;
var end_fall = 11;
var start_move_backward = 12;
var end_move_backward = 16;
var start_move_forward = 17;
var end_move_forward = 21;
var start_move_left = 22;
var end_move_left = 26;
var start_move_right = 27;
var end_move_right = 31;
var start_punch = 32;
var end_punch = 34;
var start_stand = 35;
var end_stand = 37;
var start_win = 38;
var end_win = 42;






var x_dist_between_otto_herbie;
var y_dist_between_otto_herbie;

var herbie_state_attack_block = 0; // 1 = attacking 2 = blocking;
var alea;

var mpressr=0;
var mpressl=0;






bmap herbie_health_map = <left_health.pcx>;
bmap otto_health_map = <right_health.pcx>;

//Sounds
sound gong_sound = <frogboxgong.wav>;
sound punch_dummy_sound = <punch_dummy.wav>;





panel left_health_pan
{
pos_x = 20;
pos_y = 30;
layer = 1;
hbar = 0,0,200,otto_health_map,2,left_health;
flags = d3d,overlay,refresh;
}

panel right_health_pan
{
pos_y = 30;
layer = 1;
hbar = 0,0,200,herbie_health_map,2,right_health;
flags = d3d,overlay,refresh;
}

//Functions
function main()
{
	freeze_mode = 1;
	warn_level = 2; // announce bad texture sizes and bad wdl code
	tex_share = on; // map entities share their textures

	// center the splash screen for non-640x480 resolutions
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on; // set it visible
	wait(3); // wait 3 frames (for triple buffering) until it is renderight and flipped to the foreground
	// wait the required second, then switch the splashscreen off.
	waitt(16);
	splashscreen.visible = off;
	bmap_purge(splashmap); // remove logo bitmap from video memory

	mouse_mode = 0;wait(3);
	level_load(level_str);
	wait(2);
	//+++ load starting values
	freeze_mode = 0;
	
	camera.pan = 90;
	camera.tilt = 345;
	camera.x = 0;
	camera.y = -224;
	camera.z = 101;
	
	right_health_pan.pos_x = screen_size.x - (bmap_width(herbie_health_map) + 20);
	right_health_pan.visible = on;
	left_health_pan.visible = on;

	//game();
  set_camera();
  health_panels();
}

function set_camera()
{
  while(!F_1 || !F_2){wait(1);}
  proc_late();
  camera.pan=F_2.pan+20;
  camera.tilt=-20;
  while(1)
  {
    camera.pan-=mouse_force.x*5;
    camera.pan%=360;
    camera.tilt=clamp(camera.tilt+mouse_force.y*5,-20,8);
    
    vec_lerp(temp.x,F_1.x,F_2.x,0.5);
    camera_distance.x=min(vec_dist(F_1.x,F_2.x)*2,280);
    camera_distance.z=clamp(camera_distance.x,0,30);
    vec_set(temp2.x,nullvector);temp2.x=-camera_distance.x;temp2.z=camera_distance.z;
    vec_rotate(temp2.x,camera.pan);
    vec_add(temp2.x,temp.x);
    
    trace_mode=ignore_me+ignore_you+ignore_passents+ignore_passable+ignore_models+ignore_sprites;
    if(trace(temp.x,temp2.x)==0){vec_set(camera.x,temp2.x);}  //trace where camera should be
    else{vec_set(camera.x,target.x);}  //hits anithing
    wait(1);
  }
}

function health_panels()
{
  while(!F_1 || !F_2){wait(1);}
  while(1)
  {
    right_health=max(F_1.health,0);
    left_health=max(F_2.health,0);
    wait(1);
  }
}

function fall_down()
{
  play_sound (dead_sound,50);
  my.pan=0;
  my.state=fall;
  my.anim=0;
  while(my.anim<90)
  {
    ent_animate(me,"fall",my.anim,anm_cycle);
    my.anim=min(my.anim+5*time,90);
    wait(1);
  }
  if(my==F_1){F_2.state=win;}  //if loser was frog1
  else{F_1.state=win;}
}

action blink
{
my.red = 64;
my.green = 64;
my.blue = 64; 
my.transparent=on;
my.alpha=0;
my.lightrange = 100; 
}

action ring
{
	my.shadow=on;
}

////////////////////////////////////////////////////
//Frog 1
/*
action frog_1
{
	var pp=0;
	F_1=my;
	wait(1);
	my.skill1=100;
	while(my.skill1>0)
	{
		vec_Set(temp.x,f_2.x);
		vec_sub(temp.x,my.x); 
		vec_to_angle(my.pan,temp.x);
		
		
		my.pan+=irrit_f1;if(irrit_f1>0)
		{
			irrit_f1-=15*time; 
			irrit_f1=max(0,irrit_f1);
		}
		if(irrit_f1<0)
		{
			irrit_f1+=15*time; 
			irrit_f1=min(0,irrit_f1);
		}
		vec_set(temp.x,my.x);
		temp.z-=5000;wait(1);
	}
	
}
*/
////////////////////////////////////////////////////
//Frog 2
/*
action frog_2
{

	F_2=my; 
	wait(1);
	while(f_1.skill1>0)
	{
		vec_Set(temp.x,f_1.x); vec_sub(temp.x,my.x); vec_to_angle(my.pan,temp.x);
		wait(1);
	}
}

function pos_camera()
{
camera.z = 90;
camera.x = ((f_1.x+f_2.x)/2);
camera.y = - ((f_1.x-f_2.x) + 50);
wait (1);
}

function game()
{
	wait (100);
	otto_state_of_mind = prudent;
	//play_sound (gong_sound,100);
	while (1)
	{

		//here left action


		//here right action

		f_2_anime:
		//here left animation
		x_dist_between_otto_herbie = f_1.x - f_2.x;
		y_dist_between_otto_herbie = f_2.y - f_1.y;		
		if (herbie_action_state== waiting)
		{
			anim+=5*time; 
			ent_animate(f_2,"stand",anim,anm_cycle);
		}
		
		if((mouse_left==1) && (herbie_action_state != win) && (herbie_action_state != dead) &&(mpressl==0))
		{
			anim = 0;		
			while(anim < 100)		
			{	
				mpressl=1;
				anim+=20*time; 			
				ent_animate(f_2,"punch",anim,0);	
				if (f_2.frame == 34) {ent_animate(f_2,"null",anim,0); } 
				wait(1);		
			}

			
			//have we hit right player ?
			//right may be dodging
			if (otto_action_state == dodging)
			{
				play_sound (dodge_sound,100);
			}
			if ((x_dist_between_otto_herbie < min_dist_between_otto_herbie) && (y_dist_between_otto_herbie < min_dist_between_otto_herbie))
			{
				play_sound (punch_sound,50);
				if (right_health > 0) 
				{
					right_health -= 5;
				}	
				if(vec_dist(f_1,f_2)<42 && irrit_f1==0)
				{
					irrit_f1=-100+random(200);
					f_1.skill1-=5*time;
					f_1.skill1=max(0,f_1.skill1);
				}	
			
			}


		}
		
		
		//Otto is knocked out
		if (right_health == 0)
		{
			//right has been knocked out
			otto_action_state = dead;
			anim+=5*time; 
			ent_animate(f_1,"fall",anim,anm_add);
			//left has won
			herbie_action_state = win;
			anim+=15*time; 
			ent_animate(f_2,"win",anim,anm_cycle);
		}	
		

		if(mouse_left==0)
		{
			ent_animate(f_2,"null",anim,anm_cycle);
			mpressl=0;
		}

		if((mouse_right==1) && (herbie_action_state != win) && (herbie_action_state != dead) &&(mpressl==0))
		{
			anim = 0;		
			while(anim < 100)		
			{
				mpressr=1;
				anim+=20*time; 
				ent_animate(f_2,"block",anim,0);
				wait(1);		
			}
		}

		if(mouse_right==0)
		{	
			ent_animate(f_2,"null",anim,anm_cycle);
			mpressr=0;
		}
		
		if (key_any==0) && ((herbie_action_state != win) && (herbie_action_state != dead))
		{
				anim+=20*time; 
				ent_animate(f_2,"stand",anim,anm_cycle);
		}
		
		x_dist_between_otto_herbie = f_1.x - f_2.x; //left move forward if not win and not dead
    
		if ((key_cur == 1) && (herbie_action_state != win) && (herbie_action_state != dead))
		{
			anim+=20*time; 
			ent_animate(f_2,"move_forward",anim,anm_cycle);
			//make sure left can move to right
			if (x_dist_between_otto_herbie > min_dist_between_otto_herbie)
			{
				f_2.x += 2;
				pos_camera();
			}
		}
		//left move backward if not win and not dead
		if ((key_cul == 1) && (herbie_action_state != win) && (herbie_action_state != dead))
		{
			anim+=20*time; 
			ent_animate(f_2,"move_backward",anim,anm_cycle);
			//make sure left can not out left edge
			if (f_2.x > left_edge)
			{
				f_2.x -= 2;
				pos_camera();
			}
		}
		if ((key_cud == 1) && (herbie_action_state != win) && (herbie_action_state != dead))
		{
			anim+=20*time; 
			ent_animate(f_2,"move_right",anim,anm_cycle);
			//make sure left can not out lower edge
			if (f_2.y > lower_edge)
			{
				f_2.y -= 2;
				pos_camera();
			}
		}
		if ((key_cuu == 1) && (herbie_action_state != win) && (herbie_action_state != dead))
		{
			anim+=20*time; 
			ent_animate(f_2,"move_backward",anim,anm_cycle);
			//make sure left can not out upper edge
			if (f_2.y < upper_edge)
			{
				f_2.y += 2;
				pos_camera();
			}
		}
    
		wait(1);
			
	}

		f_1_anime:
		//here right animation
		x_dist_between_otto_herbie = f_1.x - f_2.x;
		if (otto_action_state == waiting)
		{
		anim+=50*time; 
		ent_animate(f_1,"stand",anim,anm_cycle);
		}
		
		fin:
		wait(1);
	}
}







// Desc: this is the function used to restart the game.
function	main_restart_game()
{
	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// now load the level
	level_load(level_str);
	// freeze the game
	freeze_mode = 1;

	wait(2);	// 1-level loads, 2-entities load

//+++ load starting values

	// un-freeze the game
	freeze_mode = 0;
}


// Desc: this is the function used to quit the game.
function	main_quit()
{
//+++			// save global skills & strings
	exit;
}


/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;
*/